/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2006

   Read text file as in BIG5 encoding, convert to UTF8 and write to cout

   Build: make a_iconv
*/
#include "WyFileStat.h"     // for getting file size
#include "WyRegFile.h"      // for system regular file
#include "WyStr.h"
#include "WyIConv.h"        // for locale text conversion

static const WyStr IFName("../src/mid_ord.big5");

int main()
try {
 WyRegFile infile(IFName,O_RDONLY);
 WyStr rbuf,obuf;
 WyRet r;

 // Get file size and set capacity of rbuf
 {
   WyFileStat stt;
   if((r=infile.stat(stt))!=Ok) {
     WY_THROW(r);
   }
   if((r=rbuf._reserve(stt.sf_size()))!=Ok) {
     WY_THROW(r);
   }
 }

 // Read the whole file into rbuf
 infile >> rbuf;

 // Convert rbuf as in BIG5 encoding to UTF8 encoding stored into obuf
 {
   WyIConv cvrt("UTF8","BIG5");
   size_t n_rev;
   WyCSeg rseg( rbuf.cseg() );
   if((r=cvrt.iconv(rseg,obuf,n_rev))!=Ok) {
     WY_THROW(r);
   }
 }

 // Write obuf to standard output
 Wy::cout << obuf;
 return(0);
}
catch(const WyRet& e) {
 if(e!=Ok) {
   Wy::cerr << Wy::wrd(e) << '\n';
 }
 return e->repcode();
}
catch(...) {
 Wy::cerr << "main caught(...)\n";
 throw;
};
