/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2006

   Reading from /dev/urandom

   Build: make a_urandom (or g++ t_urandom.cpp -pthread -lwy -lpthread)
*/
#include "WyChrFile.h"   // for reading /dev/urandom
#include "WyStr.h"

static const WyStr DevName("/dev/urandom");

int main()
try {
 WyChrFile mh(DevName,O_RDONLY);

 // Read and dump random unsigned char's
 for(int i=0; i<20; ++i) {
   unsigned char vaa;
   mh >> vaa;
   Wy::cout << vaa << ' ';
 }
 Wy::cout << "\n\n";

 // Read and dump random unsigned int's
 for(int i=0; i<20; ++i) {
   unsigned int vbb;
   size_t n_rd;
   WyRet r;
   if((r=Wy::full_read(mh,&vbb,sizeof(vbb),n_rd))!=Ok) {
     WY_THROW( WyByteFlow::Reply(r) );
   }
   Wy::cout << vbb << ' ';
 }

 Wy::cout << "\nOk\n";
 return(0);
}
catch(const WyRet& e) {
 if(e!=Ok) {
   Wy::cerr << Wy::wrd(e) << '\n';
 }
 return e->repcode();
}
catch(...) {
 Wy::cerr << "main caught(...)\n";
 throw;
};
