/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2003

   Demonstrate usage of WyReply

   Build: make demo_reply
*/
#include "WyStr.h"
#include "WyByteFlow.h"  // for Wy::cout and operator<<

int main()
try {

 // Print errno 0-Wy::_max_errno associated WyReply
 //
 for(int i=0; i<=Wy::_max_errno; ++i) {
   const WyReply ei(i);
   Wy::cerr << i << "  " << Wy::wrd(ei) << '\n';
 }

 // Print the libwy added reply's
 //
 Wy::cout << "\nWym_ETHRDCAN " << Wy::wrd(Wym_ETHRDCAN);
 Wy::cout << "\nWym_EDIVZERO " << Wy::wrd(Wym_EDIVZERO);
 Wy::cout << "\nWym_EBADTYPE " << Wy::wrd(Wym_EBADTYPE);
 Wy::cout << "\n";

 // Print the note
 //
 Wy::cerr << "\n -- Note --\n";
 Wy::cerr << "WyReply()="     << Wy::wrd(WyReply()) << '\n';
 Wy::cerr << "WyReply(0)=Ok=" << Wy::wrd(Ok) << '\n';
 Wy::cerr << "Ok="            << Wy::wrd(Ok) << '\n';

 return(0);
}
catch(const WyRet& e) {
 Wy::cerr << Wy::wrd(e) << '\n';
 return(-1);
}
catch(...) {
 Wy::cerr << "main() caught(...)\n";
 throw;
};
