/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2007

    Demonstrate WyTimeSpec conversion can be precise 
    (suitable for dealing with price,..,in radix 10)

    Build: make demo_timespec
*/
#include "WyByteFlow.h"   // for Wy::cout
#include "WyTimeSpec.h"
#include "WyStr.h"

int main()
try {
 const WyTimeSpec price2("1.11");   // price2 is exactly 1.11
 WyTimeSpec price1(0,1);

 Wy::cout << "Precise addition\n";
 for(size_t i=0; i<20; ++i) {
   const WyTimeSpec sum= price1+price2;
   Wy::cout << price1 << " + " << price2 <<  " = " << sum << '\n';
   price1=sum;
 };
 return(0);
}
catch(const WyRet& e) {
 Wy::cerr << Wy::wrd(e) << '\n';
 throw;
}
catch(...) {
 Wy::cout << "main caught(...)\n";
 throw;
};
