/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2003
*/
#define WYLIB_SOURCE
#include "WyChrFile.h"
#include <memory>   // for new
#include <typeinfo>

const char WyChrFile::class_name[]="WyChrFile";

Wy__FtBits WyChrFile::cftbits() WY__NOTHROW__
{
 static const Wy__FtBits fb( Wy__FtBits(S_IFCHR) );
 return(fb);
};

WyChrFile::WyChrFile()
try : WyByteFlow(cftbits()) {
}
catch(const WyByteFlow::Reply& e) {
  WY_THROW( Reply(e) );
}
catch(const WyRet& e) {
 WY_NDEBUG_MSG(e);
  WY_THROW( WyRet(e) );
};

WyChrFile::WyChrFile(WyFileHandle fh)
try : WyByteFlow(fh,cftbits()) {
}
catch(const WyByteFlow::Reply& e) {
  WY_THROW( Reply(e) );
}
catch(const WyRet& e) {
 WY_NDEBUG_MSG(e);
  WY_THROW( WyRet(e) );
};

WyChrFile::WyChrFile(const WySysFile& chrf)
try : WyByteFlow(chrf,cftbits()) {
}
catch(const WyByteFlow::Reply& e) {
  WY_THROW( Reply(e) );
}
catch(const WyRet& e) {
 WY_NDEBUG_MSG(e);
  WY_THROW( WyRet(e) );
};

WyChrFile::WyChrFile(const char* pathname,int f)
try : WyByteFlow(pathname,f,cftbits()) {
}
catch(const WyByteFlow::Reply& e) {
  WY_THROW( Reply(e) );
}
catch(const WyRet& e) {
 WY_NDEBUG_MSG(e);
  WY_THROW( WyRet(e) );
};

WyChrFile::WyChrFile(const WyStr& pathname,int f)
try : WyByteFlow(pathname,f,cftbits()) {
}
catch(const WyByteFlow::Reply& e) {
  WY_THROW( Reply(e) );
}
catch(const WyRet& e) {
 WY_NDEBUG_MSG(e);
  WY_THROW( WyRet(e) );
};

WyChrFile::WyChrFile(const WyChrFile &chrf)
try : WyByteFlow(chrf,cftbits()) {
}
catch(const WyByteFlow::Reply& e) {
  WY_THROW( Reply(e) );
}
catch(const WyRet& e) {
 WY_NDEBUG_MSG(e);
  WY_THROW( WyRet(e) );
};

WyChrFile::WyChrFile(WyChrFile& chrf, Wy::ByMove_t) WY__TSPC()
 : WyByteFlow(chrf,Wy::ByMove)
{
};

WyChrFile* WyChrFile::_alloc(WyRet& r) const
try {
 if(WY__EQU_TYPEID(*this,WyChrFile)==false) {
   r=Wym_ENOSYS; WY_HERE(r);        // _alloc not overridden
   return(NULL);
 }
 WyChrFile* p=new(std::nothrow) WyChrFile();
 if(p==NULL) {
   r=Wym_ENOMEM; WY_HERE(r);
 } else {
   r=Ok;
 }
 return(p);
}
catch(const Reply& e) {
 r=e; WY_HERE(r);
 return(NULL);
}
catch(const WyRet& e) {
 WY_NDEBUG_MSG(e);
 WY_THROW( WyRet(e) );
};
