/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2003
*/

#ifndef WYDIRENT_H__
#define WYDIRENT_H__
#define WYDIRENT_VERSION 33

#include "WyRet.h"
#include <sys/types.h>
#include <dirent.h>

/*
   WyDirEnt defines the data item that Wy_DirFile reads.
*/
class WyDirEnt {
  public:
    static const char class_name[];
    WY_THROW_REPLY;

    WyDirEnt() WY__TSPC();
    WyDirEnt(const WyDirEnt &src) WY__TSPC();
    WyDirEnt(WyDirEnt &src, Wy::ByMove_t) WY__TSPC();

    // This member is not documented
    WyDirEnt(const struct dirent& dt) WY__TSPC();

    bool is_default() const WY__TSPC();

    ino_t dt_ino() const WY__TSPC();
    const char* dt_name() const WY__TSPC();
    
    void reset() WY__TSPC();
    void reset(const WyDirEnt &src) WY__TSPC();
    void swap(WyDirEnt& src) WY__TSPC();
    const WyDirEnt& operator =(const WyDirEnt &rhs) WY__TSPC();

    bool operator ==(const WyDirEnt& rhs) const WY__TSPC();
    bool operator !=(const WyDirEnt& rhs) const WY__TSPC();

    // [Internal] Get ::dirent reference of this object
    //
    struct ::dirent& wy_dent_ref() WY__NOTHROW__;
    const struct ::dirent& wy_dent_ref() const WY__NOTHROW__;
  private:
    struct ::dirent _ent;
};

#endif
