/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2003
*/

#ifndef WYICONV_H__
#define WYICONV_H__
#define WYICONV_VERSION 33

#include "WyRet.h"
#include <iconv.h>

class WyStr;
class WyCSeg;

/*
  Refer to Linux Programmer's Manual, iconv(3)
*/
class WyIConv {
    static const ::iconv_t _DefaultICD;
    ::iconv_t _icd;

    // Hidden
    WyIConv(const WyIConv&);
    const WyIConv& operator=(const WyIConv&);
    bool operator==(const WyIConv&) const;

  public:
    static const char class_name[];
    WY_THROW_REPLY;

    WyIConv() WY__TSPC();
    WyIConv(const char* tocode, const char* fromcode);

    ~WyIConv();
    
    WyRet reset();
    WyRet reset(const char* tocode, const char* fromcode);

    WyRet iconv(WyCSeg& in_range, WyStr& out_buf,size_t& n_reversible);
    WyRet iconv();
    WyRet iconv(WyStr& shiftseq);
};

#endif
