/* Copyright license: GNU LGPL (see file COPYING)           by I.J.Wang (2004)
*/

#define WYLIB_SOURCE
#include "WyMath.h"
#include <cmath>       // for modf

namespace Wy {

}; // End of Wy

double WyMath::_scif(double x, double& p10)
{
 if(x<=0) {
   if(x==0) {
     return(p10=0.0);  // return(0.0)
   }
   double frac=std::modf(std::log10(-x),&p10);
   if(frac<0) {
     frac+=1.0;
     p10-=1.0;
   }
   return(-std::pow(10.0,frac));
 } else {
   double frac=std::modf(std::log10(x),&p10);
   if(frac<0) {
     frac+=1.0;
     p10-=1.0;
   }
   return(std::pow(10.0,frac));
 }
};
