/* Copyright is licensed by GNU LGPL.                         by I.J.Wang 2007
*/
#define WYLIB_SOURCE
#include "WyRet.h"
#include "Wy_Array.hh"

typedef float VEType;

Wy_Array<VEType>::Wy_Array() : Wy__ArrayValue<VEType>()
{};

Wy_Array<VEType>::Wy_Array(size_type s,const VEType& elem) : Wy__ArrayValue<VEType>(s,elem)
{};

Wy_Array<VEType>::Wy_Array(const WySeg<VEType>& src) : Wy__ArrayValue<VEType>(src)
{};

Wy_Array<VEType>::Wy_Array(const WySeg<const VEType>& src) : Wy__ArrayValue<VEType>(src)
{};

Wy_Array<VEType>::Wy_Array(const Wy_Array& s) : Wy__ArrayValue<VEType>(s)
{};

Wy_Array<VEType>::Wy_Array(Wy_Array<VEType>& p, Wy::ByMove_t t) : Wy__ArrayValue<VEType>(p,t)
{};

void Wy_Array<VEType>::reset()
{
 Wy__ArrayValue<VEType>::reset();
};

void Wy_Array<VEType>::reset(const WySeg<const VEType>& src)
{
 Wy__ArrayValue<VEType>::reset(src);
};

void Wy_Array<VEType>::reset(const WySeg<VEType>& src)
{
 Wy__ArrayValue<VEType>::reset(src);
};

void Wy_Array<VEType>::reset(size_type n_elem, const VEType& elem)
{
 Wy__ArrayValue<VEType>::reset(n_elem,elem);
};

void Wy_Array<VEType>::reset(const Wy_Array<VEType>& src)
{
 Wy__ArrayValue<VEType>::reset(src);
};

void Wy_Array<VEType>::swap(Wy_Array<VEType>& src) WY__TSPC()
{
 Wy__ArrayValue<VEType>::swap(src);
};

void Wy_Array<VEType>::push_back(const VEType& elem)
{
 Wy__ArrayValue<VEType>::push_back(elem);
};

void Wy_Array<VEType>::pop_back()
{
 Wy__ArrayValue<VEType>::pop_back();
};

void Wy_Array<VEType>::erase(size_type idx, size_type n)
{
 Wy__ArrayValue<VEType>::erase(idx,n);
};

void Wy_Array<VEType>::insert(size_type idx, const VEType elem)
{
 Wy__ArrayValue<VEType>::insert(idx,elem);
};

void Wy_Array<VEType>::insert(size_type idx, size_type n_elem, const VEType elem)
{
 Wy__ArrayValue<VEType>::insert(idx,n_elem,elem);
};

void Wy_Array<VEType>::insert(size_type idx, const WySeg<const VEType>& src)
{
 Wy__ArrayValue<VEType>::insert(idx,src);
};

void Wy_Array<VEType>::insert(size_type idx, const WySeg<VEType>& src)
{
 Wy__ArrayValue<VEType>::insert(idx,src);
};

void Wy_Array<VEType>::insert(size_type idx, const Wy_Array<VEType>& src)
{
 Wy__ArrayValue<VEType>::insert(idx,src);
};

void Wy_Array<VEType>::replace(size_type idx, size_type slen, size_type n_elem, const VEType& elem)
{
 Wy__ArrayValue<VEType>::replace(idx,slen,n_elem,elem);
};

void Wy_Array<VEType>::resize(size_type nsize)
{
 Wy__ArrayValue<VEType>::resize(nsize);
};

void Wy_Array<VEType>::resize(size_type nsize, const VEType& elem)
{
 Wy__ArrayValue<VEType>::resize(nsize, elem);
};

const Wy_Array<VEType>& Wy_Array<VEType>::operator= (const WySeg<VEType>& rhs)
{
 return (Wy_Array<VEType>&) Wy__ArrayValue<VEType>::operator=(rhs) ; 
};

const Wy_Array<VEType>& Wy_Array<VEType>::operator=(const Wy_Array<VEType>& rhs)
{
 return (Wy_Array<VEType>&) Wy__ArrayValue<VEType>::operator=(rhs); 
};

bool Wy_Array<VEType>::operator==(const Wy_Array<VEType>& rhs) const
{
 return Wy__ArrayValue<VEType>::operator==(rhs);
};

bool Wy_Array<VEType>::operator!=(const Wy_Array<VEType>& rhs) const
{
 return Wy__ArrayValue<VEType>::operator!=(rhs);
};

Wy_Array<VEType>::size_type Wy_Array<VEType>::_capacity() const WY__TSPC()
{
 return Wy__ArrayValue<VEType>::_capacity();
};

WyRet Wy_Array<VEType>::_reserve(size_type rcap) WY__TSPC()
{
 return Wy__ArrayValue<VEType>::_reserve(rcap);
};
