/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2005

   Check WyByteFlow public members

   Build: make chk_byteflow

   Note: Test data files should exist in the working directory
         Files may be created in the working directory and unlinked
*/

#include "WyByteFlow.h"
#include "WyStr.h"
#include <sys/types.h>
#include <unistd.h>
#include <iostream>

#if WYBYTEFLOW_VERSION!=33
#error Test code is for WYBYTEFLOW_VERSION 33
#endif

extern void ck_byteflow(void);

static const WyStr chdr(
                  "+------------------+\n"
                  "| main(..) caught: |\n"
                  "+------------------+\n");
int main(void) throw()
try {
 std::cout << "Checking WyByteFlow.h ...\n";
 if(std::strcmp(WyByteFlow::class_name,"WyByteFlow")!=0) {
   WY_THROW( WyRet() );
 }
 ck_byteflow();
 std::cout << "Checked Ok\n";
 return(0);
}
catch(const WyRet& e) {
 std::cerr << chdr.c_str() << Wy::wrd(e).c_str() << std::endl;
 return(-1);
}
catch(const std::exception& e) {
 std::cerr << chdr.c_str() << "std::exception" << std::endl;
 return(-1);
}
catch(...) {
 std::cerr << chdr.c_str() << "unknown unwind" << std::endl;
 return(-1);
};
