/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2003

   Check WyChrFile public members

   Build: make chk_chrfile

   Note: Test data files should exist in the working directory
         Files may be created in the working directory and unlinked
*/

#include "WyStr.h"
#include "WyChrFile.h"

#if WYCHRFILE_VERSION!=33
#error Test code is for WYCHRFILE_VERSION 33
#endif

extern void ck_chrfile(bool);

static const WyStr chdr(
                  "+------------------+\n"
                  "| main(..) caught: |\n"
                  "+------------------+\n");
int main(void) throw()
try {
 Wy::cout << "Checking WyChrFile.h ... ";
 if(std::strcmp(WyChrFile::class_name,"WyChrFile")!=0) {
   WY_THROW( WyRet() );
 }
 ck_chrfile(true);
 Wy::cout << "Checked Ok\n";
 return(0);
}
catch(const WyRet& e) {
 Wy::cerr << chdr << Wy::wrd(e) << '\n';
 return(-1);
}
catch(...) {
 Wy::cerr << chdr << "unknown unwind\n";
 return(-1);
};
