/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2003

   Check Wy_DirFile public members

   Build: make chk_dirfile

   Note: Test data files should exist in the working directory
         Files may be created in the working directory and unlinked
*/

#include "Wy_DirFile.h"
#include "WyStr.h"
#include <sys/types.h>
#include <unistd.h>
#include <sys/wait.h>
#include <iostream>

#if WY_DIRFILE_VERSION!=33
#error Test code is for WY_DIRFILE_VERSION 33
#endif

extern void ck_dirfile(void);

static WyStr chdr("+---------------+\n"
                  "| main() caught:|\n"
                  "+---------------+\n");
int main(void) throw()
try {
 std::cout << "Checking Wy_DirFile.h ... ";
 if(std::strcmp(Wy_DirFile::class_name,"Wy_DirFile")!=0) {
   WY_THROW( WyRet() );
 }
 ck_dirfile();
 std::cout << "Checked Ok\n";
 return(0);
}
catch(const WyRet& e) {
 std::cerr << chdr.c_str() << Wy::wrd(e).c_str() << std::endl;
 return(-1);
}
catch(const std::exception& e) {
 std::cerr << chdr.c_str() << "std::exception" << std::endl;
 return(-1);
}
catch(...) {
 std::cerr << chdr.c_str() << "unknown unwind" << std::endl;
 return(-1);
};
