/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2003

   Check WyRegFile public members

   Build: make chk_regfile

   Note: Test data files should exist in the working directory
         Files may be created in the working directory and unlinked
*/

#include "WyRegFile.h"
#include "chk_data.h"
#include <unistd.h>

#if WYREGFILE_VERSION!=33
#error Test code is for WYREGFILE_VERSION 33
#endif

extern void ck_regfile(bool,const char*);

static const WyStr chdr(
                  "+------------------+\n"
                  "| main(..) caught: |\n"
                  "+------------------+\n");
int main(void) throw()
try {
 Wy::cout << "Checking WyRegFile.h ... ";
 if(std::strcmp(WyRegFile::class_name,"WyRegFile")!=0) {
   WY_THROW( WyRet() );
 }
 ck_regfile(true,"WyTimeSpec.cpp");
 Wy::cout << "Checked Ok\n";
 return(0);
}
catch(const WyRet& e) {
 Wy::cerr << chdr << Wy::wrd(e) << '\n';
 return(-1);
}
catch(...) {
 Wy::cerr << chdr << "unknown unwind\n";
 return(-1);
};
