/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2005

   Check functions in wy_iouty.h

   Build: chk_uty
*/

#include "WyStr.h"
#include "wy_iouty.h"
#include <iostream>   // for std::cerr/cout

#if WY_IOUTY_VERSION!=33
#error Test code is for WY_IOUTY_VERSION 33
#endif

extern void ck_uty(void);

static const WyStr chdr(
                  "+---------------+\n"
                  "| main() caught:|\n"
                  "+---------------+\n");
int main(void) throw()
try {
 std::cout << "Checking wy_iouty.cpp... ";
 ck_uty();
 std::cout << "Checked Ok\n";
 return(0);
}
catch(const WyRet& e) {
 std::cerr << chdr.c_str() << Wy::wrd(e).c_str() << std::endl;
 return(-1);
}
catch(...) {
 std::cerr << chdr.c_str() << "unknown unwind type\n";
 return(-1);
};
