/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2003
*/
#include "WyDate.h"
#include <iostream>

#if WYDATE_VERSION!=33
#error Test code is for WYDATE_VERSION 33
#endif


struct ChkData {
  const char* time_zone;
  int year;
  int month;
  int mday;
  int hour;
  int min;
  int sec;
  int wday;
  int yday;
  WyTimeSpec utc_time;
};

// Warning: These check data is generated by localtime_r/mktime.
//          Only consistency can be proved
//
static const ChkData cdt[]={
 {":Europe/Berlin",2003,1,17,23,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Asia/Taipei",2003,1,18,6,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":America/Detroit",2003,1,17,17,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":America/Miquelon",2003,1,17,19,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":America/Martinique",2003,1,17,18,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":America/Cordoba",2003,1,17,19,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":America/Chicago",2003,1,17,16,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":America/Tijuana",2003,1,17,14,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":America/Indianapolis",2003,1,17,17,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Pacific/Apia",2003,1,17,11,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Pacific/Honolulu",2003,1,17,12,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Pacific/Easter",2003,1,17,17,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":America/Whitehorse",2003,1,17,14,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":America/lnuvik",2003,1,17,22,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":America/New_York",2003,1,17,17,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":America/Anguilla",2003,1,17,18,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Atlantic/Reykjavik",2003,1,17,22,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Europe/Dublin",2003,1,17,22,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Europe/Bratislava",2003,1,17,23,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Europe/Madrid",2003,1,17,23,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Europe/Athens",2003,1,18,0,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Africa/Freetown",2003,1,17,22,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Africa/johannesburg",2003,1,17,22,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Africa/Bujumbura",2003,1,18,0,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Africa/Lome",2003,1,17,22,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Africa/Malabo",2003,1,17,23,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Europe/Bucharest",2003,1,18,0,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Asia/Oral",2003,1,18,2,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Asia/Kuwait",2003,1,18,1,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Indian/Antananarivo",2003,1,18,1,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Asia/Hovd",2003,1,18,5,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Asia/Thimphu",2003,1,18,4,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Asia/Ulaanbaatar",2003,1,18,6,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Asia/Chongqing",2003,1,18,6,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Asia/Taipei",2003,1,18,6,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Asia/Pontianak",2003,1,18,5,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Asia/Tokyo",2003,1,18,7,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Asia/Shanghai",2003,1,18,6,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Asia/Seoul",2003,1,18,7,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Asia/Anadyr",2003,1,18,10,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Australia/Perth",2003,1,18,6,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Australia/Sydney",2003,1,18,9,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Pacific/Niue",2003,1,17,11,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Pacific/Wake",2003,1,18,10,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Pacific/Auckland",2003,1,18,11,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Asia/Singapore",2003,1,18,6,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Europe/Paris",2003,1,17,23,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Europe/London",2003,1,17,22,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Europe/Berlin",2003,1,17,23,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Europe/Moscow",2003,1,18,1,34,49,6,17,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Antarctical/Palmer",2003,1,17,22,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 {":Arctic/Longyearbyen",2003,1,17,23,34,49,5,16,WyTimeSpec(1042842889,WyTimeSpec::NanoSecType())},
 };

static const size_t cdt_size=sizeof(cdt)/sizeof(ChkData);

static bool chk_default(const WyDate& date)
{
 if(date.utc_time().nano()!=0) {
   WY_THROW( WyRet() );
 }
 if(date.is_default()==false) {
   return(false);
 }

 {
  const static WyDate D0;
  if(date==D0) {}
  else {
    return(false);
  }
  if(date!=D0) {
    return(false);
  }
 }

 if(date.time_zone()!=WyDate::TIMEZONE_UTC) {
   return(false);
 }
 if(date.year()!=1970) {
   return(false);
 }
 if(date.month()!=1) {
   return(false);
 }
 if(date.mday()!=1) {
   return(false);
 }
 if(date.hour()!=0) {
   return(false);
 }
 if(date.min()!=0) {
   return(false);
 }
 if(date.sec()!=0) {
   return(false);
 }
 if(date.wday()!=4) {
   return(false);
 }
 if(date.yday()!=0) {
   return(false);
 }
 if(date.utc_time()!=WyTimeSpec(WyTimeSpec::SecondType(),WyTimeSpec::NanoSecType())) {
   return(false);
 }
 if(date.isdst()!=0) {
   return(false);
 }
 return(true);
};

static bool chk_not_default(const WyDate& date)
{
 return !chk_default(date);
};

static bool chk_equ(const WyDate& d1, const WyDate& d2)
{
 if(d1.utc_time().nano()!=0) {
   WY_THROW( WyRet() );            // nano-second of WyDate currently zero
 }
 if(d2.utc_time().nano()!=0) {
   WY_THROW( WyRet() );
 }
 if(d1!=d2) {
   return(false);
 }
 if(d1.time_zone()!=d2.time_zone()) {
   return(false);
 }
 if(d1.year()!=d2.year()) {
   return(false);
 }
 if(d1.month()!=d2.month()) {
   return(false);
 }
 if(d1.mday()!=d2.mday()) {
   return(false);
 }
 if(d1.hour()!=d2.hour()) {
   return(false);
 }
 if(d1.min()!=d2.min()) {
   return(false);
 }
 if(d1.sec()!=d2.sec()) {
   return(false);
 }
 if(d1.wday()!=d2.wday()) {
   return(false);
 }
 if(d1.yday()!=d2.yday()) {
   return(false);
 }
 if(d1.utc_time()!=d2.utc_time()) {
   return(false);
 }
 if(d1.isdst()!=d2.isdst()) {
   return(false);
 }
 if(d1!=d2) {
   WY_THROW( WyRet() );
 }
 if(d1==d2) {}
 else {
   WY_THROW( WyRet() );
 }
 return(true);
};

#define CHK_EQU(expr1,expr2) if(chk_equ(expr1,expr2)==false) { WY_THROW( WyRet() ); };

#define CHK_DEFAULT(expr) if(chk_default(expr)==false) { WY_THROW( WyRet() ); };
#define CHK_NOT_DEFAULT(expr) if(chk_not_default(expr)==false) { WY_THROW( WyRet() ); };

static bool chk_equ(const WyDate& dat, const ChkData& cd)
{
 if(dat.time_zone()!=cd.time_zone) {
   return(false);
 }
 if(dat.year()!=cd.year) {
   return(false);
 }
 if(dat.month()!=cd.month) {
   return(false);
 }
 if(dat.hour()!=cd.hour) {
   return(false);
 }
 if(dat.min()!=cd.min) {
   return(false);
 }
 if(dat.sec()!=cd.sec) {
   return(false);
 }
 if(dat.wday()!=cd.wday) {
   return(false);
 }
 if(dat.yday()!=cd.yday) {
   return(false);
 }
 if(dat.utc_time()!=cd.utc_time) {
   return(false);
 }
 return(true);
};

//
// Check basic (set_systime() not tested)
//
static void t_date1(void)
{
 WyRet r;
 
 // WyDate()/WyDate(const WyDate&)
 {
   WyDate a,b(a);

   CHK_DEFAULT(a);
   CHK_DEFAULT(b);
   CHK_EQU(a,b);
 }

 // WyDate(const char*,int,int,int,int,int,int)
 // WyDate(const WyStr&,int,int,int,int,int,int)
 {
  for(size_t i=0; i<cdt_size; ++i) {
    const ChkData& cd=cdt[i];
    WyDate smp(cd.time_zone,cd.year,cd.month,cd.mday,cd.hour,cd.min,cd.sec);
    CHK_EQU(smp,cd);

    WyDate tmp(smp);
    CHK_EQU(tmp,smp);
  }
  for(size_t i=0; i<cdt_size; ++i) {
    const ChkData& cd=cdt[i];
    WyDate smp(WyStr(cd.time_zone),cd.year,cd.month,cd.mday,cd.hour,cd.min,cd.sec);
    CHK_EQU(smp,cd);

    WyDate tmp(smp);
    CHK_EQU(tmp,smp);
  }
 }

 // WyDate(const char*,const WyTimeSpec&)
 // WyDate(const WyStr&,const WyTimeSpec&)
 {
  for(size_t i=0; i<cdt_size; ++i) {
    const ChkData& cd=cdt[i];
    WyDate smp(cd.time_zone,cd.utc_time);
    CHK_EQU(smp,cd);
  }
  for(size_t i=0; i<cdt_size; ++i) {
    const ChkData& cd=cdt[i];
    WyDate smp(WyStr(cd.time_zone),cd.utc_time);
    CHK_EQU(smp,cd);
  }
 }

 // reset()
 {
  const ChkData& cd=cdt[0];
  WyDate d0(cd.time_zone,cd.year,cd.month,cd.mday,cd.hour,cd.min,cd.sec);
  WyDate tmp;

  CHK_DEFAULT(tmp);
  tmp.reset();
  CHK_DEFAULT(tmp);

  d0.reset();
  CHK_DEFAULT(d0);
 }

 // reset(const WyDate&)
 {
  for(size_t i=0; i<cdt_size; ++i) {
    const ChkData& cd=cdt[i];
    WyDate smp(cd.time_zone,cd.utc_time);
    CHK_EQU(smp,cd);
    WyDate tmp;
    if((r=tmp.reset(smp))!=Ok) {
      WY_THROW(r);
    }
    CHK_EQU(tmp,smp);
  }
 }

 // reset(const char*,const WyTimeSpec&)
 // reset(const WyStr&,const WyTimeSpec&)
 {
  for(size_t i=0; i<cdt_size; ++i) {
    const ChkData& cd=cdt[i];
    WyDate smp(cd.time_zone,cd.year,cd.month,cd.mday,cd.hour,cd.min,cd.sec);
    CHK_EQU(smp,cd);
    WyDate tmp;
    if((r=tmp.reset(smp.time_zone(),smp.utc_time()))!=Ok) {
      WY_THROW(r);
    }
    CHK_EQU(tmp,smp);
  }
  for(size_t i=0; i<cdt_size; ++i) {
    const ChkData& cd=cdt[i];
    WyDate smp(WyStr(cd.time_zone),cd.year,cd.month,cd.mday,cd.hour,cd.min,cd.sec);
    CHK_EQU(smp,cd);
    WyDate tmp;
    if((r=tmp.reset(smp.time_zone(),smp.utc_time()))!=Ok) {
      WY_THROW(r);
    }
    CHK_EQU(tmp,smp);
  }
 }

 // reset(const char*,int,int,int,int,int,int)
 // reset(const WyStr&,int,int,int,int,int,int)
 {
  for(size_t i=0; i<cdt_size; ++i) {
    const ChkData& cd=cdt[i];
    WyDate smp(cd.time_zone,cd.year,cd.month,cd.mday,cd.hour,cd.min,cd.sec);
    CHK_EQU(smp,cd);
    WyDate tmp;
    if((r=tmp.reset(smp.time_zone(),smp.year(),smp.month(),smp.mday(),
                      smp.hour(),smp.min(),smp.sec()))!=Ok) {
      WY_THROW(r);
    }
    CHK_EQU(tmp,smp);
  }
  for(size_t i=0; i<cdt_size; ++i) {
    const ChkData& cd=cdt[i];
    WyDate smp(WyStr(cd.time_zone),cd.year,cd.month,cd.mday,cd.hour,cd.min,cd.sec);
    CHK_EQU(smp,cd);
    WyDate tmp;
    if((r=tmp.reset(smp.time_zone(),smp.year(),smp.month(),smp.mday(),
                      smp.hour(),smp.min(),smp.sec()))!=Ok) {
      WY_THROW(r);
    }
    CHK_EQU(tmp,smp);
  }
 }

 // swap
 {
  const ChkData& cd=cdt[0];
  const WyDate Nobj(cd.time_zone,cd.year,cd.month,cd.mday,cd.hour,cd.min,cd.sec);

  WyDate tmp0(Nobj),tmp1,tmp2;
  WyDate& rt0(tmp0),&rt1(tmp1),&rt2(tmp2);
  CHK_NOT_DEFAULT(tmp0);
  CHK_DEFAULT(tmp1);
  CHK_DEFAULT(tmp2);
  CHK_NOT_DEFAULT(Nobj);
  CHK_EQU(tmp0,rt0);
  CHK_EQU(tmp1,rt1);
  CHK_EQU(tmp2,rt2);

  tmp1.swap(tmp2);
  CHK_DEFAULT(tmp1);
  CHK_DEFAULT(tmp2);
  CHK_EQU(tmp1,rt1);
  CHK_EQU(tmp2,rt2);

  tmp1.swap(tmp0);
  CHK_DEFAULT(tmp0);
  CHK_NOT_DEFAULT(tmp1);
  CHK_EQU(tmp1,Nobj);
  CHK_EQU(tmp0,rt0);
  CHK_EQU(tmp1,rt1);

  tmp0.swap(tmp1);
  CHK_DEFAULT(tmp1);
  CHK_NOT_DEFAULT(tmp0);
  CHK_EQU(tmp0,Nobj);
  CHK_EQU(tmp0,rt0);
  CHK_EQU(tmp1,rt1);

  // chk time_zone effect
  tmp0=Nobj;
  tmp1.reset();
  const WyStr& tz0( tmp0.time_zone() );
  const WyStr& tz1( tmp1.time_zone() );

  if(tmp0.time_zone()==tmp1.time_zone()) {
    WY_THROW( WyRet() );
  }
  if(tmp0.time_zone()!=Nobj.time_zone()) {
    WY_THROW( WyRet() );
  }
  if(tmp1.time_zone()!="UTC") {
    WY_THROW( WyRet() );
  }
  if(tz0!=Nobj.time_zone()) {
    WY_THROW( WyRet() );
  }
  if(tz1!="UTC") {
    WY_THROW( WyRet() );
  }
  tmp0.swap(tmp1);
  if(tmp1.time_zone()!=Nobj.time_zone()) {
    WY_THROW( WyRet() );
  }
  if(tmp0.time_zone()!="UTC") {
    WY_THROW( WyRet() );
  }
  if(tz0!=Nobj.time_zone()) {
    WY_THROW( WyRet() );
  }
  if(tz1!="UTC") {
    WY_THROW( WyRet() );
  }
 }

 // set_utc(const WyTimeSpec&)
 {
  WyDate tmp(":Asia/Taipei",2000,1,2,3,4,5);

  if((r=tmp.set_utc(WyTimeSpec(-28800,WyTimeSpec::NanoSecType())))!=Ok) {
    WY_THROW(r);
  }
  if(tmp.year()!=1970) {
    WY_THROW( WyRet() );
  }
  if(tmp.month()!=1) {
    WY_THROW( WyRet() );
  }
  if(tmp.mday()!=1) {
    WY_THROW( WyRet() );
  }
  if(tmp.hour()!=0) {
    WY_THROW( WyRet() );
  }
  if(tmp.min()!=0) {
    WY_THROW( WyRet() );
  }
  if(tmp.sec()!=0) {
    WY_THROW( WyRet() );
  }
  if(tmp.utc_time()!=WyTimeSpec(-28800,WyTimeSpec::NanoSecType())) {
    WY_THROW( WyRet() );
  }
 }

 // set_date(int,int,int,int,int,int)
 {
  WyDate tmp(":Asia/Taipei",2000,1,2,3,4,5);

  if((r=tmp.set_date(1970,1,1,0,0,0))!=Ok) {
    WY_THROW(r);
  }
  if(tmp.year()!=1970) {
    WY_THROW( WyRet() );
  }
  if(tmp.month()!=1) {
    WY_THROW( WyRet() );
  }
  if(tmp.mday()!=1) {
    WY_THROW( WyRet() );
  }
  if(tmp.hour()!=0) {
    WY_THROW( WyRet() );
  }
  if(tmp.min()!=0) {
    WY_THROW( WyRet() );
  }
  if(tmp.sec()!=0) {
    WY_THROW( WyRet() );
  }
  if(tmp.utc_time()!=WyTimeSpec(-28800,WyTimeSpec::NanoSecType())) {
    WY_THROW( WyRet() );
  }
 }

 // add
 {
  WyDate tmp(":Asia/Taipei",2000,1,2,3,4,5);
  if((r=tmp.add(WyTimeSpec(61,WyTimeSpec::NanoSecType())))!=Ok) {
    WY_THROW(r);
  }
  if(tmp.min()!=5) {
    WY_THROW( WyRet() );
  }
  if(tmp.sec()!=6) {
    WY_THROW( WyRet() );
  }
  // 2000-1-2 03:05 6"

  if((r=tmp.add(WyTimeSpec(60*60,WyTimeSpec::NanoSecType())))!=Ok) {
    WY_THROW(r);
  }
  if(tmp.hour()!=4) {
    WY_THROW( WyRet() );
  }
  if(tmp.min()!=5) {
    WY_THROW( WyRet() );
  }
  if(tmp.sec()!=6) {
    WY_THROW( WyRet() );
  }
 }

 // operator =
 {
  const ChkData& cd=cdt[0];
  WyDate d0(cd.time_zone,cd.year,cd.month,cd.mday,cd.hour,cd.min,cd.sec),tmp;
  CHK_NOT_DEFAULT(d0);
  CHK_DEFAULT(tmp);
  tmp=d0;
  CHK_EQU(d0,tmp);
 }

 // operator +=
 {
  WyDate tmp(":Asia/Taipei",2000,1,2,3,4,5);

  tmp+=WyTimeSpec(61,WyTimeSpec::NanoSecType());
  if(tmp.min()!=5) {
    WY_THROW( WyRet() );
  }
  if(tmp.sec()!=6) {
    WY_THROW( WyRet() );
  }
  // 2000-1-2 03:05 6"

  tmp+=WyTimeSpec(60*60,WyTimeSpec::NanoSecType());
  if(tmp.hour()!=4) {
    WY_THROW( WyRet() );
  }
  if(tmp.min()!=5) {
    WY_THROW( WyRet() );
  }
  if(tmp.sec()!=6) {
    WY_THROW( WyRet() );
  }
 }

 // operator +
 {
  WyDate d0(":America/Chicaco",2000,1,2,3,4,5);
  WyDate tmp;
  CHK_DEFAULT(tmp);

  tmp= d0+WyTimeSpec(62,WyTimeSpec::NanoSecType());
  if(d0.time_zone()!=tmp.time_zone()) {
    WY_THROW( WyRet() );
  }
  if(tmp.min()!=5) {
    WY_THROW( WyRet() );
  }
  if(tmp.sec()!=7) {
    WY_THROW( WyRet() );
  }

  tmp.reset();
  CHK_DEFAULT(tmp);
  tmp= WyTimeSpec(62,WyTimeSpec::NanoSecType())+d0;
  if(d0.time_zone()!=tmp.time_zone()) {
    WY_THROW( WyRet() );
  }
  if(tmp.min()!=5) {
    WY_THROW( WyRet() );
  }
  if(tmp.sec()!=7) {
    WY_THROW( WyRet() );
  }
 }

 // chk move ctor
 {
  const WyTimeSpec tm(123,345);
  char buf[2*sizeof(WyDate)];
  
  ::memset(buf,0,sizeof(buf));
  WyDate*p=reinterpret_cast<WyDate*>(buf);
  new(p) WyDate("UTC",tm);
  new(p+1) WyDate(*p,Wy::ByMove);
  if(*(p+1)!=WyDate("UTC",tm)) {
    (p+1)->~WyDate();
    WY_THROW( WyRet() );
  }
  (p+1)->~WyDate();
 }
};

static void t_error(void)
{
 WyRet r;
 WyDate d1,d2;

 // WyDate(const char*,const WyTimeSpec&)
 try {
   WyDate tmp((const char*)0,WyTimeSpec());
   WY_THROW( WyRet() );
 }
 catch(const WyDate::Reply& e) {
   if(e!=Wym_EFAULT) {
     WY_THROW( WyRet(e) );
   }
 }
 catch(...) {
   WY_TERMINATE("");
 };

 // WyDate(const &Str,const WyTimeSpec&)
 try {
   WyDate tmp(WyStr(""),WyTimeSpec());
   WY_THROW( WyRet() );
 }
 catch(const WyDate::Reply& e) {
   if(e!=Wym_EINVAL) {
     WY_THROW( WyRet(e) );
   }
 }
 catch(...) {
   WY_TERMINATE("");
 };

 // WyDate(const char*,int,int,int,int,int,int)
 try {
   WyDate tmp((const char*)0,2000,1,2,3,4,5);
   WY_THROW( WyRet() );
 }
 catch(const WyDate::Reply& e) {
   if(e!=Wym_EFAULT) {
     WY_THROW( WyRet(e) );
   }
 }
 catch(...) {
   WY_TERMINATE("");
 };

 // WyDate(const WyStr&,int,int,int,int,int,int)
 try {
   WyDate tmp(WyStr(""),2000,1,2,3,4,5);
   WY_THROW( WyRet() );
 }
 catch(const WyDate::Reply& e) {
   if(e!=Wym_EINVAL) {
     WY_THROW( WyRet(e) );
   }
 }
 catch(...) {
   WY_TERMINATE("");
 };

 // WyDate(const WyStr&,int,int,int,int,int,int)
 try {
   WyDate tmp(WyStr(":Europe/Berlin"),-100,-2,-3,-4,-5,-6);
   WY_THROW( WyRet() );
 }
 catch(const WyDate::Reply& e) {
   if(e!=Wym_EINVAL) {
     WY_THROW( WyRet(e) );
   }
 }
 catch(...) {
   WY_TERMINATE("");
 };

 // reset(const char*,const WyTimeSpec&)
 {
  WyDate tmp;
  CHK_DEFAULT(tmp);
  if((r=tmp.reset((const char*)0,WyTimeSpec()))!=Wym_EFAULT) {
    WY_THROW(r);
  }
  CHK_DEFAULT(tmp);
 }

 // reset(const WyStr&,const WyTimeSpec&)
 {
  WyDate tmp;
  CHK_DEFAULT(tmp);
  if((r=tmp.reset(WyStr(""),WyTimeSpec()))!=Wym_EINVAL) {
    WY_THROW(r);
  }
  CHK_DEFAULT(tmp);
 }

 // reset(const char*,int,int,int,int,int,int)
 {
  WyDate tmp;
  CHK_DEFAULT(tmp);
  if((r=tmp.reset(":Africa/Freetown",3000,1,1,0,0,0))!=Wym_ERANGE) {
    WY_THROW(r);
  }
  CHK_DEFAULT(tmp);
  if((r=tmp.reset("",3000,1,1,0,0,0))!=Wym_EINVAL) {
    WY_THROW(r);
  }
  CHK_DEFAULT(tmp);
 }

 // reset(const WyStr&,int,int,int,int,int,int)
 {
  WyDate tmp;
  CHK_DEFAULT(tmp);
  if((r=tmp.reset(WyStr(":Africa/Freetown"),3000,1,1,0,0,0))!=Wym_ERANGE) {
    WY_THROW(r);
  }
  CHK_DEFAULT(tmp);
  if((r=tmp.reset(WyStr(""),3000,1,1,0,0,0))!=Wym_EINVAL) {
    WY_THROW(r);
  }
  CHK_DEFAULT(tmp);
 }

 // set_utc(const WyTimeSpec&)
 {
 }

 // set_date(int,int,int,int,int,int)
 {
  WyDate tmp;
  if((r=tmp.set_date(3000,1,1,0,0,0))!=Wym_ERANGE) {
    WY_THROW(r);
  }
 }

 // operator+=(const WyTimeSpec&)
 try {
   WyDate tmp("UTC",WyTimeSpec::max());
   tmp+=WyTimeSpec(1,WyTimeSpec::NanoSecType());
   WY_THROW( WyRet() );
 }
 catch(const WyDate::Reply& e) {
   if(e!=Wym_ERANGE) {
     WY_THROW(r);
   }
 };

 // operator +(const WyTimeSpec&,const WyDate&)
 try {
   WyDate tmp("UTC",WyTimeSpec::max());
   tmp= tmp+WyTimeSpec(1,WyTimeSpec::NanoSecType());
   WY_THROW( WyRet() );
 }
 catch(const WyDate::Reply& e) {
   if(e!=Wym_ERANGE) {
     WY_THROW(r);
   }
 };
};

void ck_date(void)
{
 t_date1();
 t_error();
};
