
#include "tsthread.h"
#include "WyByteFlow.h"
#include "Wy_AtDestroy.hh"

void TsThread::_gck(void)
{
 thread_state();

 if(thread_self()==Wy_Thread::Wy__Default_ThreadID) {
   WY_TERMINATE("");
 }
 if(::pthread_equal(Wy_Thread::thread_self(),
                               ::pthread_self())==false) {
   WY_TERMINATE("");
 }
 if(dynamic_cast<TsThread*>(tbase_ptr())!=this) {
   WY_TERMINATE("");
 }
 bool pre_can=set_cancelable(false);
 pre_can=set_cancelable(pre_can);
 if(pre_can!=false) {
   WY_TERMINATE("");
 }
 if(active_threads()<=0) {
   WY_TERMINATE("");
 }
 if(max_threads()<=0) {
   WY_TERMINATE("");
 }
};

WyRet TsThread::reset(ExitType et, WyReply retv, WyTimeSpec delay)
{
 _etype=et;
 _re_value=retv;
 _wtm.reset(delay);
 WyRet r;
 if((r=Wy_Thread::reset())!=Ok) {
   WY_RETURN(r);
 }
 return(Ok);
};

static const bool EntLeaMsg=false;
WyRet TsThread::tmain(void)
try {
 if(EntLeaMsg) {
   Wy::cerr << "TsThread::tmain() entered --> "; 
 }
 WyRet r;
 if(Wy_Thread::tbase_ptr()!=static_cast<Wy_Thread*>(this)) {
   WY_THROW( WyRet() );
 }
 try {
   this->cancel();
   WY_THROW( WyRet() );
 }
 catch(const WyRet& e) {
   if(e!=Wym_EPERM) {
     throw;
   }
 };

 try {
   this->wait_not(Null);
   WY_THROW( WyRet() );
 }
 catch(const WyRet& e) {
   if(e!=Wym_EPERM) {
     throw;
   }
 };

 try {
   this->wait_not(Active);
   WY_THROW( WyRet() );
 }
 catch(const WyRet& e) {
   if(e!=Wym_EPERM) {
     throw;
   }
 };

 try {
   this->wait_not(Stopped);
   WY_THROW( WyRet() );
 }
 catch(const WyRet& e) {
   if(e!=Wym_EPERM) {
     throw;
   }
 };

 switch(_etype) {
   case Return: {
                _gck();
                cancel_point();
                Wy::sleep(_wtm);
                _gck();
                if(EntLeaMsg) {
                  Wy::cerr << "TsThread::tmain() returned\n";
                }
                return(_re_value);
              }; break;
   case Exit: {
                _gck();
                cancel_point();
                Wy::sleep(_wtm);
                _gck();
                if(EntLeaMsg) {
                  Wy::cerr << "TsThread::tmain() exited\n";
                }
                exit(_re_value);
              }; break;
   case Reset:
   case Cancel: {
                for(;;) {
                  _gck();
                  Wy::sleep(WyTimeSpec(0,100000000));  // cancel point
                  yield();
                  cancel_point();
                }
              } break;
   default:
        WY_TERMINATE("");
 };
 if(EntLeaMsg) {
   Wy::cerr << "TsThread::tmain() returned\n";
 }
}
catch(const WyRet& e) {
 if(EntLeaMsg) {
   Wy::cerr << "TsThread::tmain() stack unwound by "
            << Wy::wrd(e) << '\n';
 }
 throw;
}
catch(...) {
 if(EntLeaMsg) {
   Wy::cerr << "TsThread::tmain() stack unwound by ...\n";
 }
 throw;
};
