
#ifndef TSTHREAD_H__

#include "Wy_Thread.h"

// [Syn] TsThread is a class for testing Wy_Thread
//
//
class TsThread : public Wy_Thread {
  public:
    enum ExitType { Return, Exit, Cancel, Reset };

    // Construct object with specified arguments
    //   et   = exit type (Return|Exit|Cancel|Reset)
    //   retv = return/exit WyRet
    //   delay= time delay before return/exit
    //
    TsThread(ExitType et, WyReply retv, WyTimeSpec delay)
           : Wy_Thread(),_etype(et),_re_value(retv),_wtm(delay)
           {};

    ~TsThread() WY__TSPC()
           {
            Wy_Thread::tmain_close();
           };

    ExitType exit_type(void) { return _etype; };

    WyRet reset(void) { return Wy_Thread::reset(); };
    WyRet reset(ExitType et, WyReply retv, WyTimeSpec delay);
  protected:
   virtual WyRet tmain(void);

  private:
    void _gck(void);

    ExitType _etype;
    WyReply _re_value;
    WyTimeSpec _wtm;
};

#endif
