/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2005

   For inclusion to implement operator<<
*/

#ifndef WY__PUT_VALUE_HH__
#define WY__PUT_VALUE_HH__

#include "WyByteFlow.h"
#include "WyNum.h"
#include "WyStr.h"
#include "WyTimeSpec.h"

template <typename NumT>
inline WyByteFlow& wy__put_value(WyByteFlow& bf, NumT num)
try {
 WyRet r;
 WyStr str;
 size_t n_wr;
 if((r=Wy::_mkstr(str,num,Wy::WyRadix(10)))!=Ok) {
   WY_THROW( WyByteFlow::Reply(r) );
 }
 if((r=Wy::full_write(bf,str.data(),str.size(),n_wr))!=Ok) {
   WY_THROW( WyByteFlow::Reply(r) );
 }
 if(n_wr!=str.size()) {
   WY_THROW( WyByteFlow::Reply(Wym_EIO) );
 }
 return(bf);
}
catch(const WyStr::Reply& e) {
 WY_THROW( WyByteFlow::Reply(e) );
};

template <>
inline WyByteFlow& wy__put_value<double>(WyByteFlow& bf, double num)
try {
 WyRet r;
 WyStr str;
 size_t n_wr;
 if((r=Wy::_mkstr(str,num,Wy::WyRadix(10),6))!=Ok) {
   WY_THROW( WyByteFlow::Reply(r) );
 }
 if((r=Wy::full_write(bf,str.data(),str.size(),n_wr))!=Ok) {
   WY_THROW( WyByteFlow::Reply(r) );
 }
 if(n_wr!=str.size()) {
   WY_THROW( WyByteFlow::Reply(Wym_EIO) );
 }
 return(bf);
}
catch(const WyStr::Reply& e) {
 WY_THROW( WyByteFlow::Reply(e) );
};

template <>
inline WyByteFlow& wy__put_value<float>(WyByteFlow& bf, float num)
try {
 WyRet r;
 WyStr str;
 size_t n_wr;
 if((r=Wy::_mkstr(str,num,Wy::WyRadix(10),6))!=Ok) {
   WY_THROW( WyByteFlow::Reply(r) );
 }
 if((r=Wy::full_write(bf,str.data(),str.size(),n_wr))!=Ok) {
   WY_THROW( WyByteFlow::Reply(r) );
 }
 if(n_wr!=str.size()) {
   WY_THROW( WyByteFlow::Reply(Wym_EIO) );
 }
 return(bf);
}
catch(const WyStr::Reply& e) {
 WY_THROW( WyByteFlow::Reply(e) );
};

template <>
inline WyByteFlow& wy__put_value<WyTimeSpec>(WyByteFlow& bf, WyTimeSpec num)
try {
 WyRet r;
 WyStr str;
 size_t n_wr;
 if((r=Wy::_mkstr(str,num,Wy::WyRadix(10),9))!=Ok) {
   WY_THROW( WyByteFlow::Reply(r) );
 }
 if((r=Wy::full_write(bf,str.data(),str.size(),n_wr))!=Ok) {
   WY_THROW( WyByteFlow::Reply(r) );
 }
 if(n_wr!=str.size()) {
   WY_THROW( WyByteFlow::Reply(Wym_EIO) );
 }
 return(bf);
}
catch(const WyStr::Reply& e) {
 WY_THROW( WyByteFlow::Reply(e) );
};

#endif
