/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2005
*/

#define WYLIB_SOURCE
#include "wy__times.h"
#include <string.h>
#include <cstdlib>
#include <limits>

const char Wy__Times::class_name[]="Wy__Times";

Wy__Times::Wy__Times() WY__TSPC()
{
 ::memset(&_tc,0,sizeof(_tc));
};

Wy__Times::Wy__Times(const Wy__Times& src) WY__TSPC()
{
 ::memcpy(&_tc,&src._tc,sizeof(_tc));
};

WyRet Wy__Times::load_times(void)
{
 if(::times(&_tc)==-1) {
   WY_RETURN(errno);
 }
 return(Ok);
};

const Wy__Times& Wy__Times::operator =(const Wy__Times& src) WY__TSPC()
{
 ::memcpy(&_tc,&src._tc,sizeof(_tc));
 return(*this);
};

WyTimeSpec Wy__Times::diff(clock_t t1, clock_t t2, clock_t divr)
{
 if(divr==0) {
   WY_THROW( Reply(Wym_EDIVZERO) );
 }
 if((std::numeric_limits<clock_t>::max()
        == std::numeric_limits<long>::max())&&
    (std::numeric_limits<clock_t>::min()
        == std::numeric_limits<long>::min())) {
   std::ldiv_t dt=std::ldiv(t1-t2,divr);
   return WyTimeSpec(dt.quot,((long long)WY__CONST_GIGA*dt.rem)/divr);
 } else if((std::numeric_limits<clock_t>::max()
        == std::numeric_limits<long long>::max())&&
    (std::numeric_limits<clock_t>::min()
        == std::numeric_limits<long long>::min())) {
   std::lldiv_t dt=std::lldiv(t1-t2,divr);
   return WyTimeSpec(dt.quot,((long long)WY__CONST_GIGA*dt.rem)/divr);
 } else {
   WY_TERMINATE("");
 }
 WY_ASSERT("UNREACHABLE");
};
