/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2004
*/

#ifndef WY_SQRT_HH__
#define WY_SQRT_HH__
#define WYLIB_SOURCE

namespace Wy {

// Note: This template only works for unsigned integer type
template <typename T>
inline T wy__sqrt(T n)
{
 if(n<=1) {
   return(n);
 }

 T s1,s2(n>>1);
 do {
   s1=s2;
   s2=(s1+n/s1)>>1;
 } while(s2<s1);

 return(s1);
};

};

#endif
