/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2007
*/

#define WYLIB_SOURCE
#include "WyNum.h"
#include "wy_parse_nstr.hh"

namespace Wy {

WyRet _strnum(char& res, const WyCSeg& nseg, Wy::WyRadix& ns_radix) WY__TSPC()
{
 const char* endptr;
 return Wy::wy_parse_nstr(res, endptr, nseg, ns_radix);
};

WyRet _strnum(char& res, const WyCSeg& nseg, const Wy::WyRadix& ns_radix) WY__TSPC()
{
 Wy::WyRadix t_radix=ns_radix;
 const char* endptr;
 return Wy::wy_parse_nstr(res, endptr, nseg, t_radix);
};

WyRet _strnum(char& res, const WyCSeg& nseg) WY__TSPC()
{
 Wy::WyRadix t_radix=10;
 const char* endptr;
 return Wy::wy_parse_nstr(res, endptr, nseg, t_radix);
};

WyRet _strnum(char& res, WyCSeg& nseg, Wy::WyRadix& ns_radix) WY__TSPC()
{
 const char* endptr;
 const WyRet r( Wy::wy_parse_nstr(res, endptr, nseg, ns_radix) );
 nseg.wy_set_begin(endptr);
 return(r);
};

WyRet _strnum(char& res, WyCSeg& nseg, const Wy::WyRadix& ns_radix) WY__TSPC()
{
 Wy::WyRadix t_radix=ns_radix;
 const char* endptr;
 const WyRet r( Wy::wy_parse_nstr(res, endptr, nseg, t_radix) );
 nseg.wy_set_begin(endptr);
 return(r);
};

WyRet _strnum(char& res, WyCSeg& nseg) WY__TSPC()
{
 Wy::WyRadix t_radix=10;
 const char* endptr;
 const WyRet r( Wy::wy_parse_nstr(res, endptr, nseg, t_radix) );
 nseg.wy_set_begin(endptr);
 return(r);
};

//--------------
WyRet _strnum(signed char& res, const WyCSeg& nseg, Wy::WyRadix & ns_radix) WY__TSPC()
{
 const char* endptr;
 return Wy::wy_parse_nstr(res, endptr, nseg, ns_radix);
};

WyRet _strnum(signed char& res, const WyCSeg& nseg, const Wy::WyRadix & ns_radix) WY__TSPC()
{
 Wy::WyRadix t_radix=ns_radix;
 const char* endptr;
 return Wy::wy_parse_nstr(res, endptr, nseg, t_radix);
};

WyRet _strnum(signed char& res, const WyCSeg& nseg) WY__TSPC()
{
 Wy::WyRadix t_radix=10;
 const char* endptr;
 return Wy::wy_parse_nstr(res, endptr, nseg, t_radix);
};

WyRet _strnum(signed char& res, WyCSeg& nseg, Wy::WyRadix & ns_radix) WY__TSPC()
{
 const char* endptr;
 const WyRet r( Wy::wy_parse_nstr(res, endptr, nseg, ns_radix) );
 nseg.wy_set_begin(endptr);
 return(r);
};

WyRet _strnum(signed char& res, WyCSeg& nseg, const Wy::WyRadix & ns_radix) WY__TSPC()
{
 Wy::WyRadix t_radix=ns_radix;
 const char* endptr;
 const WyRet r( Wy::wy_parse_nstr(res, endptr, nseg, t_radix) );
 nseg.wy_set_begin(endptr);
 return(r);
};

WyRet _strnum(signed char& res, WyCSeg& nseg) WY__TSPC()
{
 Wy::WyRadix t_radix=10;
 const char* endptr;
 const WyRet r( Wy::wy_parse_nstr(res, endptr, nseg, t_radix) );
 nseg.wy_set_begin(endptr);
 return(r);
};

//------------------------------
WyRet _strnum(unsigned char& res, const WyCSeg& nseg, Wy::WyRadix& ns_radix) WY__TSPC()
{
 const char* endptr;
 return Wy::wy_parse_nstr(res, endptr, nseg, ns_radix);
};

WyRet _strnum(unsigned char& res, const WyCSeg& nseg, const Wy::WyRadix& ns_radix) WY__TSPC()
{
 Wy::WyRadix t_radix=ns_radix;
 const char* endptr;
 return Wy::wy_parse_nstr(res, endptr, nseg, t_radix);
};

WyRet _strnum(unsigned char& res, const WyCSeg& nseg) WY__TSPC()
{
 Wy::WyRadix t_radix=10;
 const char* endptr;
 return Wy::wy_parse_nstr(res, endptr, nseg, t_radix);
};

WyRet _strnum(unsigned char& res, WyCSeg& nseg, Wy::WyRadix& ns_radix) WY__TSPC()
{
 const char* endptr;
 const WyRet r( Wy::wy_parse_nstr(res, endptr, nseg, ns_radix) );
 nseg.wy_set_begin(endptr);
 return(r);
};

WyRet _strnum(unsigned char& res, WyCSeg& nseg, const Wy::WyRadix& ns_radix) WY__TSPC()
{
 Wy::WyRadix t_radix=ns_radix;
 const char* endptr;
 const WyRet r( Wy::wy_parse_nstr(res, endptr, nseg, t_radix) );
 nseg.wy_set_begin(endptr);
 return(r);
};

WyRet _strnum(unsigned char& res, WyCSeg& nseg) WY__TSPC()
{
 Wy::WyRadix t_radix=10;
 const char* endptr;
 const WyRet r( Wy::wy_parse_nstr(res, endptr, nseg, t_radix) );
 nseg.wy_set_begin(endptr);
 return(r);
};

};  // end namespace Wy
